import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkCoupon, ThinkCouponParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkCoupon(params: ThinkCouponParam) {
  const res = await request.get<ApiResult<PageResult<ThinkCoupon>>>(
    THINK_API_URL + '/think/think-coupon/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkCoupon(params?: ThinkCouponParam) {
  const res = await request.get<ApiResult<ThinkCoupon[]>>(
    THINK_API_URL + '/think/think-coupon',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkCoupon(data: ThinkCoupon) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coupon',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkCoupon(data: ThinkCoupon) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coupon',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkCoupon(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coupon/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkCoupon(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-coupon/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkCoupon(id: number) {
  const res = await request.get<ApiResult<ThinkCoupon>>(
    THINK_API_URL + '/think/think-coupon/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
